/**
 * Created by IntelliJ IDEA.
 * User: Kilho Shin
 * Date: 11/02/21
 * Time: 11:46
 * To change this template use File | Settings | File Templates.

  This file is part of Mapping Kernels for Trees.

  Mapping Kernels for Trees is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Mapping Kernels for Trees is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Mapping Kernels for Trees.  If not, see <http://www.gnu.org/licenses/>.

  For more details about this code, please look at the companion paper
  "Mapping Kernels for Trees", K. Shin, M.Cuturi, T.Kuboyama, Proceedings of
  the International Conference on Machine Learning 2011.

 */


case class Signature(seq: List[Int]) {
  def height(): Int = seq.foldLeft(0)(_ max _)
  def length(): Int = seq.length
  def append(i: Int): Signature = Signature(i::seq)
  def <(that: Signature): Boolean = {
    this.height < that.height ||
    this.height == that.height && this.length < that.length
  }
  def head: Int = seq.head
  override def toString() = {
    "[" + seq.mkString(",") + "]"
  }
}
